import * as Mc from "@minecraft/server"
let inv_holder = []
let players = []
Mc.system.runInterval(() => {
    for (const player of Mc.world.getPlayers()) {
        try {
            for (let i = players.length - 1; i >= 0; i--) {
                if (players[i] !== player.name) continue
                let obj = Mc.world.scoreboard.getObjective('unitx:combat').getScores()
                for (let i = 0; i < obj.length; i++) {
                    if (obj[i].participant.displayName !== player.id) continue
                    if (obj[i].score == -48285) {
                        player.runCommandAsync(`clear @s`)
                        player.runCommandAsync(`kill @s`)
                        player.dimension.runCommandAsync(`scoreboard players set "${obj[i].participant.displayName}" unitx:combat 0`)
                    }
                    for (const entity of player.dimension.getEntities({ type: "unitx:player_display" })) {
                        if (entity.nameTag = player.name) {
                            entity.triggerEvent('unitx:despawn')
                            return
                        }
                    }
                    break
                }
                players.splice(i, 1)
                break
            }
        } catch (e) { }
        let hold = []
        hold.push(player.id)
        hold.push(player.location)
        hold.push(player.getComponent('health').current)
        hold.push(player.name)
        hold.push(player.getRotation())
        hold.push(player.dimension)
        const inv = player.getComponent("minecraft:inventory").container
        for (let i = 0; i < inv.size; i++) {
            const item = inv.getItem(i)
            if (!item) hold.push(undefined)
            else hold.push(item)
        }
        const head = player.getComponent('equipment_inventory').getEquipment("head")
        if (!head) hold.push(undefined)
        else hold.push(head)

        const chest = player.getComponent('equipment_inventory').getEquipment("chest")
        if (!chest) hold.push(undefined)
        else hold.push(chest)

        const legs = player.getComponent('equipment_inventory').getEquipment("legs")
        if (!legs) hold.push(undefined)
        else hold.push(legs)

        const feet = player.getComponent('equipment_inventory').getEquipment("feet")
        if (!feet) hold.push(undefined)
        else hold.push(feet)

        const offhand = player.getComponent('equipment_inventory').getEquipment("offhand")
        if (!offhand) hold.push(undefined)
        else hold.push(offhand)

        const mainhand = player.getComponent('equipment_inventory').getEquipment("mainhand")
        if (!mainhand) hold.push(undefined)
        else hold.push(mainhand)

        for (let i = 0; i < inv_holder.length; i++) {
            if (inv_holder[i][0] == player.id) {
                inv_holder[i] = hold
                break
            }
            else if (i == inv_holder.length - 1) {
                inv_holder.push(hold)
            }
        }
        if (inv_holder.length == 0) {
            inv_holder.push(hold)
        }
    }
    for (let i = 0; i < 3; i++) {
        let dimension = 'overworld'
        if (i == 1) dimension = 'nether'
        if (i == 2) dimension = 'the_end'
        for (const entity of Mc.world.getDimension(dimension).getEntities({ type: "unitx:player_display" })) {
            let tag = entity.getTags()
            for (let i = 0; i < tag.length; i++) {
                if (!tag[i].includes('player_id:')) continue
                let id = tag[i].split('player_id:')[1]
                let obj = Mc.world.scoreboard.getObjective('unitx:combat').getScores()
                for (let i = 0; i < obj.length; i++) {
                    if (obj[i].participant.displayName !== id) continue
                    if (obj[i].score > 0) break
                    entity.runCommandAsync(`scoreboard players reset "${obj[i].participant.displayName}" unitx:combat`)
                    entity.triggerEvent('unitx:despawn')
                }
                break
            }
        }
    }
})
Mc.system.runInterval(() => {
    let obj = Mc.world.scoreboard.getObjective('unitx:combat').getScores()
    for (let i = 0; i < obj.length; i++) {
        if (obj[i].score < 0 || obj[i].score == -48285) continue
        Mc.world.getDimension('overworld').runCommandAsync(`scoreboard players remove "${obj[i].participant.displayName}" unitx:combat 1`)
        if (obj[i].score == 0 && Mc.world.getDynamicProperty("combat_message") == true) {
            for (const player of Mc.world.getDimension('overworld').getEntities({ type: "minecraft:player" })) {
                if (player.id !== obj[i].participant.displayName) continue
                player.sendMessage('§aYou are no longer in combat §7You are safe to logout!')
                break
            }
        }
    }
}, 20)
Mc.world.afterEvents.playerLeave.subscribe((eventData) => {
    let obj = Mc.world.scoreboard.getObjective('unitx:combat').getScores()
    for (let i = 0; i < obj.length; i++) {
        if (obj[i].participant.displayName !== eventData.playerId) continue
        if (obj[i].score > 0) {
            for (let i = 0; i < inv_holder.length; i++) {
                if (inv_holder[i][0] !== eventData.playerId) continue
                let spawned_entity = inv_holder[i][5].spawnEntity("unitx:player_display", inv_holder[i][1])
                spawned_entity.setRotation(inv_holder[i][4])
                spawned_entity.addTag(`player_id:${inv_holder[i][0]}`)
                spawned_entity.nameTag = inv_holder[i][3]
                spawned_entity.addTag(`decimal:${inv_holder[i][2].toString().split('.', 1)[0].length}`)
                spawned_entity.runCommandAsync(`scoreboard players set @s "unitx:health_track" ${inv_holder[i][2].toFixed(5).toString().replaceAll('.', '')}`)
                for (let ii = 6; ii < inv_holder[i].length; ii++) {
                    if (inv_holder[i][ii] == undefined) continue
                    if (ii < 42) spawned_entity.getComponent("minecraft:inventory").container.setItem(ii, inv_holder[i][ii])
                    if (ii == 42) spawned_entity.getComponent("equipment_inventory").setEquipment("head", inv_holder[i][ii])
                    if (ii == 43) spawned_entity.getComponent("equipment_inventory").setEquipment("chest", inv_holder[i][ii])
                    if (ii == 44) spawned_entity.getComponent("equipment_inventory").setEquipment("legs", inv_holder[i][ii])
                    if (ii == 45) spawned_entity.getComponent("equipment_inventory").setEquipment("feet", inv_holder[i][ii])
                    if (ii == 46) spawned_entity.getComponent("equipment_inventory").setEquipment("offhand", inv_holder[i][ii])
                    if (ii == 47) spawned_entity.getComponent("equipment_inventory").setEquipment("mainhand", inv_holder[i][ii])
                }
                break
            }
            break
        }
    }
})
Mc.world.afterEvents.entityHurt.subscribe((eventData) => {
    if (!eventData.hurtEntity) return
    if (eventData.hurtEntity.typeId !== "minecraft:player") return
    if (!eventData.damageSource.damagingEntity) return
    if (eventData.damageSource.damagingEntity.typeId !== "minecraft:player") return


    const score = getScore('unitx:combat', eventData.hurtEntity)
    if ((score == 0 || score == -1) && Mc.world.getDynamicProperty("combat_message") == true) eventData.hurtEntity.sendMessage('§cYou are now in combat! §7You will be killable if you logout')
    const score2 = getScore('unitx:combat', eventData.damageSource.damagingEntity)
    if ((score2 == 0 || score2 == -1) && Mc.world.getDynamicProperty("combat_message") == true) eventData.damageSource.damagingEntity.sendMessage('§cYou are now in combat! §7You will be killable if you logout')
    eventData.hurtEntity.dimension.runCommandAsync(`scoreboard players set "${eventData.hurtEntity.id}" unitx:combat ${Mc.world.getDynamicProperty("combat_timer")}`)
    eventData.hurtEntity.dimension.runCommandAsync(`scoreboard players set "${eventData.damageSource.damagingEntity.id}" unitx:combat ${Mc.world.getDynamicProperty("combat_timer")}`)
})
Mc.world.afterEvents.entityDie.subscribe((eventData) => {
    if (!eventData.damageSource.damagingEntity) return
    if (!eventData.damageSource.damagingEntity.typeId !== 'minecraft:player') return
    if (eventData.deadEntity.typeId !== 'minecraft:player') return
    eventData.deadEntity.dimension.runCommandAsync(`scoreboard players set "${eventData.deadEntity.id}" unitx:combat 0`)
})
Mc.world.afterEvents.entityHurt.subscribe((eventData) => {
    if (eventData.hurtEntity.typeId == "unitx:player_display") {
        let tag = eventData.hurtEntity.getTags()

        let old_health = getScore('unitx:health_track', eventData.hurtEntity)
        old_health = old_health.toString().split('')
        let num = 0
        let numm = ''


        for (let i = 0; i < tag.length; i++) {
            if (!tag[i].includes('decimal:')) continue
            num = parseInt(tag[i].split('decimal:')[1])
            for (let i = 0; i < old_health.length; i++) {
                if (i == num) numm = numm + '.' + old_health[i]
                else numm = numm + old_health[i]
            }
            numm = Number(numm)
            eventData.hurtEntity.removeTag(tag[i])
            break
        }
        numm = numm - eventData.damage
        if (eventData.hurtEntity.typeId == "unitx:player_display") {
            let tag = eventData.hurtEntity.getTags()
            for (let i = 0; i < tag.length; i++) {
                if (!tag[i].includes('player_id:')) continue
                let amount = Mc.world.getDynamicProperty("combat_timer")
                if (numm <= 0) amount = -48285
                eventData.hurtEntity.dimension.runCommandAsync(`scoreboard players set "${parseInt(tag[i].split('player_id:')[1])}" unitx:combat ${amount}`)
                break
            }
        }
        if (numm <= 0) {
            let inv = eventData.hurtEntity.getComponent("minecraft:inventory").container
            for (let i = 0; i < inv.size; i++) {
                const item = inv.getItem(i)
                if (!item) continue
                eventData.hurtEntity.dimension.spawnItem(item, eventData.hurtEntity.location)
            }
            const offhand = eventData.hurtEntity.getComponent('equipment_inventory').getEquipment("offhand")
            if (offhand) eventData.hurtEntity.dimension.spawnItem(offhand, eventData.hurtEntity.location)

            const head = eventData.hurtEntity.getComponent('equipment_inventory').getEquipment("head")
            if (head) eventData.hurtEntity.dimension.spawnItem(head, eventData.hurtEntity.location)

            const chest = eventData.hurtEntity.getComponent('equipment_inventory').getEquipment("chest")
            if (chest) eventData.hurtEntity.dimension.spawnItem(chest, eventData.hurtEntity.location)

            const legs = eventData.hurtEntity.getComponent('equipment_inventory').getEquipment("legs")
            if (legs) eventData.hurtEntity.dimension.spawnItem(legs, eventData.hurtEntity.location)

            const feet = eventData.hurtEntity.getComponent('equipment_inventory').getEquipment("feet")
            if (feet) eventData.hurtEntity.dimension.spawnItem(feet, eventData.hurtEntity.location)

            eventData.hurtEntity.triggerEvent('unitx:despawn')
            return
        }
        eventData.hurtEntity.addTag(`decimal:${numm.toString().split('.', 1)[0].length}`)
        eventData.hurtEntity.runCommandAsync(`scoreboard players set @s "unitx:health_track" ${numm.toFixed(5).toString().replaceAll('.', '')}`)
    }
})

function getScore(objective, entity) {
    let obj = Mc.world.scoreboard.getObjective(objective).getScores()
    for (let i = 0; i < obj.length; i++) {
        if (obj[i].participant.displayName !== entity.id) continue
        return obj[i].score
    }
    Mc.world.getDimension('overworld').runCommandAsync(`scoreboard players set "${entity.id}" ${objective} 0`)
    return 0
}
Mc.world.afterEvents.playerJoin.subscribe((eventData) => {
    players.push(eventData.playerName)
})
Mc.world.afterEvents.worldInitialize.subscribe((eventData) => {
    const dy = new Mc.DynamicPropertiesDefinition()
    dy.defineNumber("combat_timer")
    dy.defineBoolean("combat_message")
    eventData.propertyRegistry.registerWorldDynamicProperties(dy)
    if (Mc.world.getDynamicProperty("combat_timer") == undefined) { Mc.world.setDynamicProperty("combat_timer", 60) }
    if (Mc.world.getDynamicProperty("combat_message") == undefined) { Mc.world.setDynamicProperty("combat_message", true) }
    try { Mc.world.scoreboard.addObjective('unitx:combat', 'unitx:combat') } catch (e) { }
    try { Mc.world.scoreboard.addObjective('unitx:health_track', 'unitx:health_track') } catch (e) { }
})
Mc.world.beforeEvents.chatSend.subscribe((eventData) => {
    let { message, sender } = eventData
    if (message.startsWith('-combattimer ') || message.startsWith('-combatmessages ')) eventData.cancel = true
    Mc.system.run(() => {
        if (message.startsWith('-combatmessages ')) {
            if ((message.split('-combatmessages ')[1] !== 'true') && (message.split('-combatmessages ')[1] !== 'false')) {
                sender.sendMessage('§cInvalid syntax!')
                return
            }
            if (message.split('-combatmessages ')[1] == 'true') {
                if (Mc.world.getDynamicProperty("combat_message") == true) sender.sendMessage('§cCombat messages are already enabled!')
                if (Mc.world.getDynamicProperty("combat_message") == false) sender.sendMessage('§aEnabled combat messages')
                Mc.world.setDynamicProperty("combat_message", true)
            }
            if (message.split('-combatmessages ')[1] == 'false') {
                if (Mc.world.getDynamicProperty("combat_message") == false) sender.sendMessage('§cCombat messages are already disabled!')
                if (Mc.world.getDynamicProperty("combat_message") == true) sender.sendMessage('§aDisabled combat messages')
                Mc.world.setDynamicProperty("combat_message", false)
            }
        }
        if (message.startsWith('-combattimer ')) {
            let num = Number(message.split('-combattimer ')[1])
            if (typeof num !== "number" || isNaN(num)) {
                sender.sendMessage('§cInvalid syntax!')
                return
            }
            if (num < 1 || num > 3000) {
                sender.sendMessage('§cThe combat timer must be in a range of 1-3000 seconds!')
                return
            }
            if (Mc.world.getDynamicProperty("combat_timer") == num) sender.sendMessage(`§cThe combat timer already set to §7${num}§c seconds!`)
            else {
                sender.sendMessage(`§aSet the combat timer to §7${num}§a seconds`)
                Mc.world.setDynamicProperty("combat_timer", num)
            }
        }
    })
})